package cz.muni.fi.fibot.teststrategybot;

import java.util.Random;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.World;

public class TestStrategyBot implements Strategy {
	
	private World world;
	private Robot robot;
	private int maxX, maxY;
	private int gameMap[][];
	
	public TestStrategyBot() {
		this.maxX = this.maxY = 0;
	}
	
	private int getTurningCost(Robot.Direction dir, int dx, int dy) {
		int diff = 0, diff2 = 0;
		if (dir == Robot.Direction.UP) diff = 0;
		else if (dir == Robot.Direction.DOWN) diff = 2;
		else if (dir == Robot.Direction.LEFT) diff = 1;
		else if (dir == Robot.Direction.RIGHT) diff = 3;
		else return 10000;
		if (dx == -1 && dy == 0) diff2 = 1;
		else if (dy == -1 && dx == 0) diff2 = 0;
		else if (dx == 1 && dy == 0) diff2 = 3;
		else if (dy == 1 && dx == 0) diff = 2;
		else return 10000;
		return ((4+diff-diff2) % 2);
	}
	
	
	
	private void evaluateMap() {
		
	}
	
	public void setWorld(World world) {
		this.world = world;
		this.maxX = world.getDimensionX();
		this.maxY = world.getDimensionY();
		this.gameMap = new int[maxX][maxY];
	}

	public void setRobot(Robot robot) {
		this.robot = robot;
	}

	public void initialize() {
		// NOTHING TO DO YET
	}
	
	private void readMap() {
		for (int x = 0; x < maxX; x++)
			for (int y = 0; y < maxY; y++) {
				this.gameMap[x][y] = world.getFieldValue(x,y);
			}
	}
	
	private int[] getDirection(Robot.Direction direction) {
		int dir[] = new int[2];
		if (direction == Robot.Direction.LEFT) dir[0] = -1; else
		if (direction == Robot.Direction.RIGHT) dir[0] = 1; else
		if (direction == Robot.Direction.UP) dir[1] = -1; else
		if (direction == Robot.Direction.DOWN) dir[1] = 1; 					
		return dir;
	}

	public BotAction decide() {
		int x = robot.getPositionX();
		int y = robot.getPositionY();
		readMap();
		if (robot.getEnergy() < 2) return BotAction.REST;
		if (world.containsTreasure(x, y)) return BotAction.TAKE;
		Random random = new Random();
		int what = random.nextInt(4);
		if (what == 0) return BotAction.LEFT;
		if (what == 1) return BotAction.RIGHT;
		if (what == 2) return BotAction.STEP;
		if (what == 3) return BotAction.SHOOT;
		return null;
	}

}
